\real{codeweight=\tries*0.2}
\text{Ask=randitem(Construire, Construisez, Veuillez construire,
	Ecrire, Ecrivez, Veuillez crire)}
\if{\basetype issametext fix}{
 \text{basename=\N0}
 \integer{basem1=\N0-1}
 \text{isprime=<span class="tt">\N0</span> est un nombre premier}
}{
 \text{basename=\Name}
 \text{basem1=\Name-1}
 \text{isprime=<span class="tt">\Name</span> est un nombre premier compris entre \prime1 et \prime2b}
}

\text{nstep=r1}
\nextstep{\nstep}
\integer{bad=0}
\text{badl=}
\text{repl=}
\text{suml=}
\integer{codelen=0}
\integer{badn=0}

\text{condpos=}
\text{condnonz=}
\text{condall=\isprime.}
\for{ff=1 to \parms}{
 \if{\types[\ff] iswordof pos1 pos2}{
  \text{condpos=wims(append item \parmlist[\ff] to \condpos)}
 }
 \if{\types[\ff] iswordof nonz}{
  \text{condnonz=wims(append item \parmlist[\ff] to \condnonz)}
 }
}
\if{\condpos notsametext \null}{
 \text{condpos=, isin \condpos?<span class="tt">\condpos</span> sont positifs:
 		<span class="tt">\condpos</span> est positif}
}
\if{\condnonz notsametext \null}{
 \text{condnonz=, isin \condnonz?<span class="tt">\condnonz</span> ne sont pas divisibles par <span class="tt">\basename</span>:
 		<span class="tt">\condnonz</span> n&#39;est pas divisible par <span class="tt">\basename</span>}
}
\if{\condpos notsametext \null and \condnonz notsametext \null}{
 \text{condall=\isprime, \condpos, et \condnonz.}
}{
 \if{\condpos\condnonz notsametext \null}{
  \text{condall=\isprime, et \condpos\condnonz.}
 }
}

\statement{
\Ask une fonction
<code style="color:blue;">\fnname</code>
en \lang, qui prend
\if{\argcnt==1}{un entier <span class="tt">\parmlist</span>,}
{\argcnt entiers <span class="tt">\parmlist[\argshuffle]</span>,}
et retourne la classe de
<div class="wimscenter"> \(\fml) </div>
dans \(\ZZ/\basename \ZZ) reprsente par un entier compris entre 0 et
<span class="tt">\basem1</span>. (\condall)

\if{\hint notsametext }{<div>\hint</div>}
\if{\step > 1 and \step <= \tries and \bad > 0}{
<hr />
<b>ERREUR</b>.
\if{\repl issametext \null}{
 Votre code n&#39;a rien donn. Erreur de syntaxe ?
 <pre><code style="color:red;font-size:small;">\reply_err</code></pre>
}{
Votre code n&#39;a pas pass le test sur le cas <span class="tt">\badcase</span>&nbsp;:
<p>
Il retourne \repl[\bad], alors que le rsultat correct doit tre
\suml[\bad].
</p>
}
<p>
Veuillez corriger (essai numro \step, limit  \tries).
</p>
}

\special{expandlines <code style="color:brown;">\Pre</code>}
\embed{r1,\size}
\special{expandlines <code style="color:brown;">\Post</code>}
\if{\codelim2 < 10000}{
 <p><b>ATTENTION</b>! La longueur de votre code est limite  \codelim2
 caractres sans compter les espaces.
 </p>
 \if{\codelim1 < \codelim2}{
  Et le score dpend de la longueur du code. Plus le code est court, plus le
  score est lev, jusqu&#39;au score total si la longueur ne dpasse pas \codelim1.
 }
}
\if{\name_deny notsametext }{
 <p>Les noms suivants NE SONT PAS autoriss dans le
 code&nbsp;:
 </p>
 <div class="wimscenter"> <code style="color:red;">\confparm4</code> </div>
}
}

\answer{Source}{\blabla}{type=code}{options=\lang \nonempty}

\text{suml=wims(words2items \sum)}
\text{repl=wims(line -1 of \reply_out)}
\text{repl=wims(words2items \repl)}
\integer{bad=0}

\for{i=1 to \ncnt}{
 \if{\bad=0 && \suml[\i] != \repl[\i]} {
  \integer{bad=\i}
  \text{badl=\listsc[\i]}
  \text{badl=wims(declosing \badl)}
 }
}

\text{badcase=item(1..\argcnt,\parmlist[\argshuffle[1]]=\badl[\argshuffle[1]],
\parmlist[\argshuffle[2]]=\badl[\argshuffle[2]],
\parmlist[\argshuffle[3]]=\badl[\argshuffle[3]],
\parmlist[\argshuffle[4]]=\badl[\argshuffle[4]])}

\integer{codelen=wims(charcnt wims(replace internal &#36; by t in wims(nospace \blabla)))}
\integer{codelim3=floor((3*\codelim1+\codelim2)/4)}
\integer{codelim4=floor((\codelim1+\codelim2)/2)}
\integer{codelim5=floor((\codelim1+3*\codelim2)/4)}

\text{nstep=\bad > 0 and \step <= \tries and \codelen <= \codelim2?r1:}

\condition{}{\bad = 0 and \codelen <= \codelim1}{option=hide}{weight=\codeweight}
\condition{}{\bad = 0 and \codelen <= \codelim3}{option=hide}{weight=\codeweight}
\condition{}{\bad = 0 and \codelen <= \codelim4}{option=hide}{weight=\codeweight}
\condition{}{\bad = 0 and \codelen <= \codelim5}{option=hide}{weight=\codeweight}
\condition{Votre code passe les tests}{\codelen <= \codelim2 and \bad = 0}
{weight=\codeweight}

\feedback{\repl issametext \null}{
 Votre code n&#39;a rien donn. Erreur de syntaxe ? Dsol.
}

\feedback{\codelen > \codelim2}{
 Votre code dpasse la limite de longueur ! Il a \codelen caractres, contre
 la limite de \codelim2.
}

\feedback{\repl notsametext \null and \codelen < \codelim2 and \codelen > \codelim1}{
 Une pnalit est applique parce que la longueur de votre code (\codelen)
 a dpass \codelim1.
}

\feedback{\bad > 0 and \repl notsametext \null and \codelen < \codelim2}{
Votre code n&#39;a pas pass le test sur le cas <span class="tt">\badcase</span>&nbsp;:
<p>
Il retourne \repl[\bad], alors que le rsultat correct doit tre
\suml[\bad].
</p>
}

\feedback{\bad = 0 and \codelen <= \codelim1 and \codelim1 < 99999}{
 Longueur de votre code : \codelen caractres sans les espaces.
}
